import { bold } from './bold';
import { italic } from './italic';
import { header } from './header';
import { strike } from './strike';
import { underline } from './underline';
import { olist } from './olist';
import { ulist } from './ulist';
import { link } from './link';
import { todo } from './todo';
import { image } from './image';
import { fullscreen } from './fullscreen';
import { preview } from './preview';
export var defaultCommands = {
  bold: bold,
  italic: italic,
  header: header,
  strike: strike,
  underline: underline,
  olist: olist,
  ulist: ulist,
  link: link,
  todo: todo,
  image: image,
  fullscreen: fullscreen,
  preview: preview
};
export var getCommands = function getCommands() {
  return Object.keys(defaultCommands).filter(function (key) {
    return !/^(fullscreen|preview)/.test(key);
  }).map(function (key) {
    return defaultCommands[key];
  });
};
export var getModeCommands = function getModeCommands() {
  return [preview, fullscreen];
};
//# sourceMappingURL=index.js.map