import _extends from "@babel/runtime/helpers/esm/extends";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import 'codemirror/mode/markdown/markdown';
import React, { Component } from 'react';
import "./codemirror.css";
import "./index.css";
import { jsx as _jsx } from "react/jsx-runtime";
var SERVER_RENDERED = typeof navigator === 'undefined' || global.PREVENT_CODEMIRROR_RENDER === true;
var cm;

if (!SERVER_RENDERED) {
  // tslint:disable-next-line: no-var-requires
  cm = require('codemirror');
}

var ReactCodeMirror = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ReactCodeMirror, _Component);

  // public editor!: Doc | Editor | EditorFromTextArea | Editor;
  function ReactCodeMirror(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.textarea = void 0;
    _this.editor = void 0;

    if (SERVER_RENDERED) {
      return _assertThisInitialized(_this);
    }

    if (_this.props.editorWillMount) {
      _this.props.editorWillMount();
    }

    return _this;
  }

  var _proto = ReactCodeMirror.prototype;

  _proto.render = function render() {
    var _this2 = this;

    return /*#__PURE__*/_jsx("textarea", {
      ref: function ref(instance) {
        return _this2.textarea = instance;
      }
    });
  };

  _proto.componentDidMount = function componentDidMount() {
    if (SERVER_RENDERED) {
      return;
    }

    var options = this.props.options;

    if (this.props.defineMode) {
      if (this.props.defineMode.name && this.props.defineMode.fn) {
        cm.defineMode(this.props.defineMode.name, this.props.defineMode.fn);
      }
    }

    var editorOption = _extends({
      tabSize: 2,
      lineNumbers: true
    }, options, {
      mode: 'markdown'
    }); // 生成codemirror实例


    this.editor = cm.fromTextArea(this.textarea, editorOption);
    this.renderCodeMirror(this.props);
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var _this$props = this.props,
        value = _this$props.value,
        width = _this$props.width,
        height = _this$props.height;

    if (this.editor.getValue() !== value && value !== prevProps.value) {
      this.editor.setValue(value || '');
    }

    if (width !== prevProps.width || height !== prevProps.height) {
      // Setting Size
      this.editor.setSize(width, height);
    }
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    return nextProps.value !== this.props.value || nextProps.options !== this.props.options || nextProps.height !== this.props.height || nextProps.width !== this.props.width;
  } // 将 props 中所有的事件处理函数映射并保存
  ;

  _proto.getEventHandleFromProps = function getEventHandleFromProps() {
    var propNames = Object.keys(this.props);
    var eventHandle = propNames.filter(function (prop) {
      return /^on+/.test(prop);
    });
    var eventDict = {};
    eventHandle.forEach(function (ele) {
      eventDict[ele] = ele.replace(/^on[A-Z]/g, function (s) {
        return s.slice(2).toLowerCase();
      });
    });
    return eventDict;
  };

  _proto.renderCodeMirror = function renderCodeMirror(props) {
    var _this3 = this;

    var value = props.value,
        width = props.width,
        height = props.height; // 获取CodeMirror用于获取其中的一些常量
    // 事件处理映射

    var eventDict = this.getEventHandleFromProps();
    Object.keys(eventDict).forEach(function (event) {
      var handle = _this3.props[event];

      _this3.editor.on(eventDict[event], handle);
    }); // Init value

    this.editor.setValue(value || ''); // this.editor.setOption(name, editorOption.mode);

    if (width || height) {
      // Setting size
      this.editor.setSize(width, height);
    }
  };

  return ReactCodeMirror;
}(Component);

ReactCodeMirror.defaultProps = {
  height: '100%',
  options: {
    lineNumbers: true,
    mode: 'markdown',
    tabSize: 2
  },
  value: '',
  width: '100%'
};
export { ReactCodeMirror as default };
//# sourceMappingURL=index.js.map