import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["prefixCls", "className", "onClick", "toolbars", "editor", "mode", "preview", "container", "containerEditor", "editorProps"];
import * as React from "react";
import "./index.css";
import { defaultCommands } from '../../commands';
import { createElement as _createElement } from "react";
import { jsx as _jsx } from "react/jsx-runtime";
export default function ToolBar(props) {
  var _props$prefixCls = props.prefixCls,
      prefixCls = _props$prefixCls === void 0 ? 'md-editor' : _props$prefixCls,
      className = props.className,
      onClick = props.onClick,
      _props$toolbars = props.toolbars,
      toolbars = _props$toolbars === void 0 ? [] : _props$toolbars,
      editor = props.editor,
      mode = props.mode,
      preview = props.preview,
      container = props.container,
      containerEditor = props.containerEditor,
      _props$editorProps = props.editorProps,
      editorProps = _props$editorProps === void 0 ? {} : _props$editorProps,
      htmlProps = _objectWithoutPropertiesLoose(props, _excluded);

  if (!toolbars || toolbars.length === 0) return null;

  function handleClick(execute) {
    if (execute && editor) {
      execute(editor, editor.getSelection(), editor.getCursor(), {
        preview: preview,
        container: container
      });
    }
  }

  return /*#__PURE__*/_jsx("div", _extends({
    className: prefixCls + "-toolbar " + (className || '') + " " + (mode ? prefixCls + "-toolbar-mode" : '')
  }, htmlProps, {
    children: [].concat(toolbars).map(function (command, key) {
      var buttonProps = {
        type: 'button'
      };
      var obj = typeof command === 'string' ? defaultCommands[command] : command;
      if (!obj) return null;
      buttonProps.children = obj.icon;

      buttonProps.onClick = function () {
        return handleClick(obj.execute);
      };

      if (obj.button && typeof obj.button === 'object') {
        var btn = obj.button;
        Object.keys(btn).forEach(function (key) {
          buttonProps[key] = btn[key];
        });
      } else if (typeof obj.button === 'function') {
        return /*#__PURE__*/React.cloneElement(obj.button(obj, editorProps, {
          preview: preview,
          container: container,
          containerEditor: containerEditor,
          editor: editor
        }), {
          key: key
        });
      }

      return /*#__PURE__*/_createElement("button", _extends({}, buttonProps, {
        key: key
      }));
    })
  }));
}
//# sourceMappingURL=index.js.map